import HTTPS, { NetPost } from "../HTTPS";



export class WeChatSDKManager {

    private loginData = {};
    private logincode = '';
    login(callBack: Function) {
        let wx = (window as any)["wx"];
        let self = this;

        wx.login({
            success: (login_res) => {

                self.logincode = login_res.code;
                console.log("得到登录凭证code");
                console.log(login_res.code);


                let sysInfo = wx.getSystemInfoSync();
                let width = sysInfo.screenWidth;
                let height = sysInfo.screenHeight;
                wx.getSetting({
                    success(getSetting_res) {
                        console.log("wx.getSetting获取用户配置成功");
                        if (getSetting_res.authSetting['scope.userInfo']) {
                            wx.getUserInfo({
                                success: function (res) {
                                    console.log("得到用户信息数据");
                                    console.log(getSetting_res);


                                    self.loginData = res.userInfo;
                                    self.requestGameServer()
                                    callBack?.(res);
                                }
                            })
                        } else {
                            let button = wx.createUserInfoButton({
                                type: 'text',
                                text: '',
                                style: {
                                    left: 0,
                                    top: 0,
                                    width: width,
                                    height: height,
                                    lineHeight: height,
                                    // backgroundColor: '#ff0000',
                                    color: '#000000',
                                    textAlign: 'center',
                                    fontSize: 18,
                                    borderRadius: 4
                                }
                            })
                            // _disNode.active = true;
                            button.onTap((res) => {
                                // 用户同意授权后回调，通过回调可获取用户头像昵称信息
                                console.log("用户点击后_得到用户信息数据");
                                console.log(res);

                                self.loginData = res.userInfo;

                                self.requestGameServer()
                                callBack?.(res);
                                button.hide();
                            })
                            button.show();

                        }
                    },
                    // 失败回调
                    fail(res) {
                        console.log("wx.getSetting获取用户配置失败");
                        console.log(res);
                    },
                    // 结束回调(调用成功，失败都会执行)
                    complete(res) {
                        console.log("wx.getSetting获取用户配置结束");
                        console.log(res);
                    }
                })
            }
        });
    }


    requestGameServer() {
        HTTPS.Instance.post(NetPost.Login,
            {
                platform: 'wechatmini',
                code: this.logincode,
                avatar: this.loginData['avatarUrl'],
                nickname: this.loginData['nickName'],
            }).then((resp) => {
                console.error('999999999999');
                console.error(resp);

                HTTPS.Instance.token=resp.data.userinfo.token
            })
    }


    showShareMenu() {
        let wx = (window as any)["wx"];
        wx.showShareMenu({
            menus: ['shareAppMessage', "shareTimeline"],
        })
        wx.onShareAppMessage(function () {
            return {
                title: '你能挑战过吗?',
                imageUrl: ""
            }
        })

        if (wx.onShareTimeline != null) {
            wx.onShareTimeline(function () {
                return {
                    title: '你能挑战过吗?',
                    imageUrl: ""
                }
            })
        }
    }
}
