import { _decorator, Component, Label, Node } from 'cc';
import { EventManager } from './EventManager';
const { ccclass, property } = _decorator;

@ccclass('Top')
export class Top extends Component {
    @property(Label)
    haertLabel: Label = null;

    @property(Label)
    ScoreLabel: Label = null;

    protected onLoad(): void {
        EventManager.instance.et.on(EventManager.EventType.Add_haert, this.Add_haert, this);
        EventManager.instance.et.on(EventManager.EventType.Cut_haert, this.Cut_haert, this);
        EventManager.instance.et.on(EventManager.EventType.Add_Score, this.Add_Score, this);
        EventManager.instance.et.on(EventManager.EventType.Set_Add_Score_BOOL, this.Set_Add_Score_BOOL, this);
        EventManager.instance.et.on(EventManager.EventType.Reset_Score, this.Reset_Score, this);

    }

    Cut_haert() {
        if (parseInt(this.haertLabel.string) > 0) {
            this.haertLabel.string = (parseInt(this.haertLabel.string) - 1) + "";

            EventManager.instance.et.emit(EventManager.EventType.Reset_Role);
        } else {
            //死了
            console.error('死了');

            EventManager.instance.et.emit(EventManager.EventType.Set_Add_Score_BOOL, false);

            EventManager.instance.et.emit(EventManager.EventType.Die_Role);
            EventManager.instance.et.emit(EventManager.EventType.OpenUIPnael);
        }
    }


    protected start(): void {
        EventManager.instance.et.emit(EventManager.EventType.Reset_Score);
    }

    Add_haert(num: number) {
        if (parseInt(this.haertLabel.string) < 3) {
            this.haertLabel.string = (parseInt(this.haertLabel.string) + 1) + "";
        }

        if (num) {
            this.haertLabel.string = num + "";
        }
    }

    Add_Score_Bool = true
    Add_Score() {
        if (this.Add_Score_Bool) {
            this.ScoreLabel.string = (parseInt(this.ScoreLabel.string) + 10) + "";
        }
    }
    Set_Add_Score_BOOL(b: boolean) {
        this.Add_Score_Bool = b
    }

    Reset_Score() {
        this.ScoreLabel.string = '0'
    }
}


